/*
		NewShop.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Class corresponding to the dialog of the same name.
*/
#include "stdafx.h"
#include "Cbreak.h"
#include "NewShop.h"
#include "World.h"
#include "utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// NewShop dialog


NewShop::NewShop(CWnd* pParent /*=NULL*/)
	: CDialog(NewShop::IDD, pParent)
{
	//{{AFX_DATA_INIT(NewShop)
	m_shop_num = 0;
	//}}AFX_DATA_INIT
}


void NewShop::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(NewShop)
	DDX_Text(pDX, IDC_NEW_SHOP_NUM, m_shop_num);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(NewShop, CDialog)
	//{{AFX_MSG_MAP(NewShop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// NewShop message handlers

extern CCbreakApp theApp;
extern World the_world;

void NewShop::OnOK() 
{
  map<int,Zone_Data>::const_iterator zi;
  int good=0,zone_num;
  Shop *new_shop;

  UpdateData(TRUE);
  
	/* check if it's already existing */
  if(the_world.shop_list.find(m_shop_num)!= the_world.shop_list.end()) {
	  AfxMessageBox("That shop already exists!",MB_OK);
	  return;
  }
  /* check if it's in a zone or not */

  for(zi=the_world.zone_list.begin();zi != the_world.zone_list.end() && !good;zi++) {
    if(m_shop_num >= zi->second.number * 100 && m_shop_num <= zi->second.top) {
			good=1;
			zone_num = zi->second.number;
		}
  }

  if(!good) {
		AfxMessageBox("That shop would exist outside a zone!",MB_OK);
	  return;
  }

	new_shop = new Shop;
	new_shop->zone = zone_num;
	new_shop->bitvector=new_shop->with_who=0;
	new_shop->profitb = new_shop->profits = 1;
	new_shop->time[0]=new_shop->time[2]=new_shop->time[3]=0;
	new_shop->time[1]=28;
	new_shop->number = m_shop_num;
	
	the_world.shop_list[m_shop_num] = *new_shop;

	theApp.dlg->current_shop = m_shop_num;
	theApp.dlg->m_sedit.LoadSedit();
	CDialog::OnOK();
}
