/*
		sedit.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Primary control dialog for the sedit window.
*/
#pragma warning(disable:4786)
#include "stdafx.h"
#include "Cbreak.h"
#include "Sedit.h"
#include "JumpToShop.h"
#include "Shop.h"
#include "World.h"
#include "ItemQuery.h"
#include "RoomQuery.h"
#include "TypeQuery.h"
#include "NewShop.h"
#include "BitvectorSel.h"

extern CCbreakApp theApp;
extern World the_world;

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Sedit property page

IMPLEMENT_DYNCREATE(Sedit, CPropertyPage)

Sedit::Sedit() : CPropertyPage(Sedit::IDD)
{
	//{{AFX_DATA_INIT(Sedit)
	m_mesg1 = _T("");
	m_mesg2 = _T("");
	m_mesg3 = _T("");
	m_mesg4 = _T("");
	m_mesg5 = _T("");
	m_mesg6 = _T("");
	m_mesg7 = _T("");
	m_fight = FALSE;
	m_temper = FALSE;
	m_sellmult = 0.0f;
	m_open2 = 0;
	m_open1 = 0;
	m_close2 = 0;
	m_close1 = 0;
	m_buymult = 0.0f;
	m_bank = FALSE;
	m_shop_namelist = _T("");
	//}}AFX_DATA_INIT
}

Sedit::~Sedit()
{
}

void Sedit::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Sedit)
	DDX_Control(pDX, IDC_SHOP_MESG7, e_mesg7);
	DDX_Control(pDX, IDC_SHOP_MESG6, e_mesg6);
	DDX_Control(pDX, IDC_SHOP_MESG5, e_mesg5);
	DDX_Control(pDX, IDC_SHOP_MESG4, e_mesg4);
	DDX_Control(pDX, IDC_SHOP_MESG3, e_mesg3);
	DDX_Control(pDX, IDC_SHOP_MESG2, e_mesg2);
	DDX_Control(pDX, IDC_SHOP_MESG1, e_mesg1);
	DDX_Control(pDX, IDC_SHOP_NUM, m_shop_num);
	DDX_Text(pDX, IDC_SHOP_MESG1, m_mesg1);
	DDX_Text(pDX, IDC_SHOP_MESG2, m_mesg2);
	DDX_Text(pDX, IDC_SHOP_MESG3, m_mesg3);
	DDX_Text(pDX, IDC_SHOP_MESG4, m_mesg4);
	DDX_Text(pDX, IDC_SHOP_MESG5, m_mesg5);
	DDX_Text(pDX, IDC_SHOP_MESG6, m_mesg6);
	DDX_Text(pDX, IDC_SHOP_MESG7, m_mesg7);
	DDX_Check(pDX, IDC_SHOP_FIGHT, m_fight);
	DDX_Check(pDX, IDC_SHOP_TEMPER, m_temper);
	DDX_Text(pDX, IDC_SHOP_SELLMULT, m_sellmult);
	DDX_Text(pDX, IDC_SHOP_OPEN2, m_open2);
	DDX_Text(pDX, IDC_SHOP_OPEN1, m_open1);
	DDX_Text(pDX, IDC_SHOP_CLOSE2, m_close2);
	DDX_Text(pDX, IDC_SHOP_CLOSE1, m_close1);
	DDX_Text(pDX, IDC_SHOP_BUYMULT, m_buymult);
	DDX_Check(pDX, IDC_SHOP_BANK, m_bank);
	DDX_Text(pDX, IDC_SHOP_BUY_NAMELIST, m_shop_namelist);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Sedit, CPropertyPage)
	//{{AFX_MSG_MAP(Sedit)
	ON_BN_CLICKED(IDC_SHOP_PREVZ, OnShopPrevz)
	ON_BN_CLICKED(IDC_SHOP_PREV, OnShopPrev)
	ON_BN_CLICKED(IDC_SHOP_NUM, OnShopNum)
	ON_BN_CLICKED(IDC_SHOP_NEXT, OnShopNext)
	ON_BN_CLICKED(IDC_SHOP_NEXTZ, OnShopNextz)
	ON_EN_CHANGE(IDC_SHOP_BUYMULT, OnChangeShopBuymult)
	ON_EN_CHANGE(IDC_SHOP_SELLMULT, OnChangeShopSellmult)
	ON_EN_CHANGE(IDC_SHOP_OPEN1, OnChangeShopOpen1)
	ON_EN_CHANGE(IDC_SHOP_CLOSE1, OnChangeShopClose1)
	ON_EN_CHANGE(IDC_SHOP_OPEN2, OnChangeShopOpen2)
	ON_EN_CHANGE(IDC_SHOP_CLOSE2, OnChangeShopClose2)
	ON_BN_CLICKED(IDC_SHOP_TEMPER, OnShopTemper)
	ON_BN_CLICKED(IDC_SHOP_FIGHT, OnShopFight)
	ON_BN_CLICKED(IDC_SHOP_BANK, OnShopBank)
	ON_EN_CHANGE(IDC_SHOP_MESG2, OnChangeShopMesg2)
	ON_EN_CHANGE(IDC_SHOP_MESG5, OnChangeShopMesg5)
	ON_EN_CHANGE(IDC_SHOP_MESG7, OnChangeShopMesg7)
	ON_EN_CHANGE(IDC_SHOP_MESG1, OnChangeShopMesg1)
	ON_EN_CHANGE(IDC_SHOP_MESG3, OnChangeShopMesg3)
	ON_EN_CHANGE(IDC_SHOP_MESG4, OnChangeShopMesg4)
	ON_EN_CHANGE(IDC_SHOP_MESG6, OnChangeShopMesg6)
	ON_BN_CLICKED(IDC_SHOP_NEW_ITEM, OnShopNewItem)
	ON_BN_CLICKED(IDC_SHOP_DELETE_ITEM, OnShopDeleteItem)
	ON_BN_CLICKED(IDC_SHOP_DELETE_ROOM, OnShopDeleteRoom)
	ON_BN_CLICKED(IDC_SHOP_ADD_ROOM, OnShopAddRoom)
	ON_BN_CLICKED(IDC_SHOP_ADD_BUY, OnShopAddBuy)
	ON_BN_CLICKED(IDC_SHOP_DELETE_BUY, OnShopDeleteBuy)
	ON_EN_CHANGE(IDC_SHOP_BUY_NAMELIST, OnChangeShopBuyNamelist)
	ON_CBN_SELCHANGE(IDC_SHOP_BUY_COMBO, OnSelchangeShopBuyCombo)
	ON_BN_CLICKED(IDC_SHOP_TRADE, OnShopTrade)
	ON_BN_CLICKED(IDC_SHOP_SAVE, OnShopSave)
	ON_BN_CLICKED(IDC_SHOP_NEW_SHOP, OnShopNewShop)
	ON_BN_CLICKED(IDC_SHOP_DELETE_SHOP, OnShopDeleteShop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////


void Sedit::OnShopPrevz() 
{
  extern CCbreakApp theApp;
  int shop_num = theApp.dlg->current_shop;
  map<int,Zone_Data>::const_iterator zi;
  map<int,Shop>::const_iterator ri;

	zi = the_world.zone_list.find(the_world.shop_list[shop_num].zone);
	if(zi==the_world.zone_list.end()) {
		error("Crapbuger. The current zone does not exist.");
	}
  	
	for(ri=the_world.shop_list.find(shop_num);ri != the_world.shop_list.begin();ri--) {
  	if(the_world.shop_list[ri->first].zone != the_world.shop_list[shop_num].zone) {
      break;
		}
	}

	if(ri == the_world.shop_list.begin() && the_world.shop_list[ri->first].zone ==
			the_world.shop_list[shop_num].zone) {
		ri=the_world.shop_list.end();
		ri--;
	}

	theApp.dlg->current_shop = ri->first;
	this->LoadSedit();	
}

void Sedit::OnShopPrev() 
{
	extern CCbreakApp theApp;
  int shop_num = theApp.dlg->current_shop;
  map<int, Shop>::const_iterator ri;

	ri=the_world.shop_list.find(shop_num);
	if(ri == the_world.shop_list.end()) {
		/* this is a serious problem. indicates the current shop DNE! */
		error("Uh. The current shop doesn't exist?");
	} 
	if(ri == the_world.shop_list.begin()) {
		ri= the_world.shop_list.end();
	}
	ri--;
	if(ri == the_world.shop_list.end()) {
		ri=the_world.shop_list.begin();
  }
	theApp.dlg->current_shop = ri->first;

	LoadSedit();	
}

void Sedit::OnShopNum() 
{
  JumpToShop js;
  js.DoModal();
}

void Sedit::OnShopNext() 
{
	extern CCbreakApp theApp;
  int shop_num = theApp.dlg->current_shop;
  map<int, Shop>::const_iterator ri;

	ri=the_world.shop_list.find(shop_num);
	if(ri == the_world.shop_list.end()) {
		/* this is a serious problem. indicates the current shop DNE! */
		error("Uh. The current shop doesn't exist?");
	} 
	ri++;
	if(ri == the_world.shop_list.end()) {
		ri=the_world.shop_list.begin();
  }
	theApp.dlg->current_shop = ri->first;

	LoadSedit();
}

void Sedit::OnShopNextz() 
{
	extern CCbreakApp theApp;
  int shop_num = theApp.dlg->current_shop;
  map<int,Zone_Data>::const_iterator zi;
  map<int,Shop>::const_iterator ri;

	zi = the_world.zone_list.find(the_world.shop_list[shop_num].zone);
	if(zi==the_world.zone_list.end()) {
		error("Crapbuger. The current zone does not exist.");
	}
  	
	for(ri=the_world.shop_list.find(shop_num);ri != the_world.shop_list.end();ri++) {
  	if(the_world.shop_list[ri->first].zone != the_world.shop_list[shop_num].zone) {
      break;
		}
	}
	if(ri == the_world.shop_list.end()) {
		ri=the_world.shop_list.begin();
	}

	theApp.dlg->current_shop = ri->first;
	this->LoadSedit();	
}

extern const char *obj_types[];

int Sedit::LoadSedit()
{
	int shop_vnum;
	Shop *lshop;
  vector<int>::iterator ii;
  vector<BuyType>::iterator bi;

	shop_vnum= theApp.dlg->current_shop;
  lshop = &(the_world.shop_list[shop_vnum]);
 
  	if(!are_there_zones()) {
    disable_sedit(-1);
	} else if (the_world.shop_list.empty()) {
		disable_sedit(0);
	} else {
		disable_sedit(1);
  }
	if(shop_vnum < 0){
		return FALSE;
	}
	m_shop_num.SetWindowText(iprintf("%d",lshop->number));

  m_mesg1 = lshop->messages[0].c_str(); 
  m_mesg2 = lshop->messages[1].c_str(); 
  m_mesg3 = lshop->messages[2].c_str(); 
  m_mesg4 = lshop->messages[3].c_str(); 
  m_mesg5 = lshop->messages[4].c_str(); 
  m_mesg6 = lshop->messages[5].c_str(); 
  m_mesg7 = lshop->messages[6].c_str(); 

  m_sellmult = lshop->profits;
	m_buymult = lshop->profitb;
	m_temper = lshop->temper;
	m_fight = (lshop->bitvector & 1);
	m_bank  = (lshop->bitvector & 2);
	m_open1 = lshop->time[0];
	m_open2 = lshop->time[2];
	m_close1 = lshop->time[1];
	m_close2 = lshop->time[3];

	((CComboBox *) GetDlgItem(IDC_SHOP_SELL_COMBO))->ResetContent();
  
	if(!lshop->item_list.empty()) {
    for(ii = lshop->item_list.begin();ii != lshop->item_list.end();ii++) {
	   ((CComboBox *) GetDlgItem(IDC_SHOP_SELL_COMBO))->AddString(
				iprintf("%d - %s ",*ii,the_world.obj_list[*ii].sdesc.c_str()));
		}
		ii=lshop->item_list.begin();
	  ((CComboBox *) GetDlgItem(IDC_SHOP_SELL_COMBO))->SelectString(-1,
			iprintf("%d - %s ",*ii, the_world.obj_list[*ii].sdesc.c_str()));
	}
 
  if(!lshop->item_list.size()) {
		GetDlgItem(IDC_SHOP_SELL_COMBO)->EnableWindow(FALSE);
  } else {
		GetDlgItem(IDC_SHOP_SELL_COMBO)->EnableWindow(TRUE);
  }

	((CComboBox *) GetDlgItem(IDC_SHOP_ROOM_COMBO))->ResetContent();
  
	if(!lshop->room_list.empty()) {
    for(ii = lshop->room_list.begin();ii != lshop->room_list.end();ii++) {
	   ((CComboBox *) GetDlgItem(IDC_SHOP_ROOM_COMBO))->AddString(
				iprintf("%d - %s ",*ii,the_world.room_list[*ii].name.c_str()));
		}
		ii=lshop->room_list.begin();
	  ((CComboBox *) GetDlgItem(IDC_SHOP_ROOM_COMBO))->SelectString(-1,
			iprintf("%d - %s ",*ii, the_world.room_list[*ii].name.c_str()));
	}
 
  if(!lshop->room_list.size()) {
		GetDlgItem(IDC_SHOP_ROOM_COMBO)->EnableWindow(FALSE);
  } else {
		GetDlgItem(IDC_SHOP_ROOM_COMBO)->EnableWindow(TRUE);
  }

	((CComboBox *) GetDlgItem(IDC_SHOP_BUY_COMBO))->ResetContent();
  
	if(!lshop->buy_list.empty()) {
    for(bi = lshop->buy_list.begin();bi != lshop->buy_list.end();bi++) {
	   ((CComboBox *) GetDlgItem(IDC_SHOP_BUY_COMBO))->AddString(
				iprintf("%s",obj_types[bi->obj_type]));
		}
		bi=lshop->buy_list.begin();
	  ((CComboBox *) GetDlgItem(IDC_SHOP_BUY_COMBO))->SelectString(-1,
			iprintf("%s",obj_types[bi->obj_type]));
		m_shop_namelist=bi->accept_string.c_str();
	}
 
  if(!lshop->buy_list.size()) {
		GetDlgItem(IDC_SHOP_BUY_COMBO)->EnableWindow(FALSE);
  } else {
		GetDlgItem(IDC_SHOP_BUY_COMBO)->EnableWindow(TRUE);
  }
	

	UpdateData(FALSE);
  return TRUE;
}





BOOL Sedit::OnSetActive() 
{
	if(theApp.dlg->current_shop >= 0) {
		LoadSedit();
	}
	return CPropertyPage::OnSetActive();
}

void Sedit::OnChangeShopBuymult() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->profitb = m_buymult;	
	
}

void Sedit::OnChangeShopSellmult() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->profits = m_sellmult;	
	
}

void Sedit::OnChangeShopOpen1() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->time[0] = m_open1;	
}

void Sedit::OnChangeShopClose1() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->time[0] = m_close1;	
	
}

void Sedit::OnChangeShopOpen2() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->time[0] = m_open2;	
}

void Sedit::OnChangeShopClose2() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->time[0] = m_close2;	
}

void Sedit::OnShopTemper() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->temper = m_temper;		
}

void Sedit::OnShopFight() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);
  if(m_fight) {
  	lshop->bitvector |= 1;		
	}
}

void Sedit::OnShopBank() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);
  if(m_bank) {
  	lshop->bitvector |= 2;		
	}	
}

void Sedit::OnChangeShopMesg2() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->messages[1] = m_mesg2;	
	
}

void Sedit::OnChangeShopMesg5() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->messages[4] = m_mesg5;		
}

void Sedit::OnChangeShopMesg7() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->messages[6] = m_mesg7;		
}

void Sedit::OnChangeShopMesg1() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->messages[0] = m_mesg1;		
}

void Sedit::OnChangeShopMesg3() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->messages[2] = m_mesg3;	
}

void Sedit::OnChangeShopMesg4() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->messages[3] = m_mesg4;	
}

void Sedit::OnChangeShopMesg6() 
{
	Shop *lshop;

	int shop_vnum= theApp.dlg->current_shop;
  UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);

	lshop->messages[5] = m_mesg6;	
}

void Sedit::OnShopNewItem() 
{
  ItemQuery iq;
	Shop *lshop;
	int shop_vnum= theApp.dlg->current_shop;

  lshop = &(the_world.shop_list[shop_vnum]);
  iq.DoModal();
  lshop->item_list.push_back(iq.value);

  LoadSedit();
}

void Sedit::OnShopDeleteItem() 
{
	CString temp;

	Shop *lshop;
	int shop_vnum= theApp.dlg->current_shop;
  lshop = &(the_world.shop_list[shop_vnum]);
	((CComboBox *) GetDlgItem(IDC_SHOP_SELL_COMBO))->GetWindowText(temp);
	lshop->delete_item(iprintf("%s",temp));
	LoadSedit();	
}

void Sedit::OnShopDeleteRoom() 
{
	CString temp;

	Shop *lshop;
	int shop_vnum= theApp.dlg->current_shop;
  lshop = &(the_world.shop_list[shop_vnum]);
	((CComboBox *) GetDlgItem(IDC_SHOP_ROOM_COMBO))->GetWindowText(temp);
	lshop->delete_room(iprintf("%s",temp));
	LoadSedit();
}

void Sedit::OnShopAddRoom() 
{
  RoomQuery rq;

	Shop *lshop;
	int shop_vnum= theApp.dlg->current_shop;

	rq.DoModal();
  lshop = &(the_world.shop_list[shop_vnum]);
	lshop->room_list.push_back(rq.value);

  LoadSedit();
}

void Sedit::OnShopAddBuy() 
{
  TypeQuery iq;
	Shop *lshop;
	BuyType *bt;
	int shop_vnum= theApp.dlg->current_shop;

  lshop = &(the_world.shop_list[shop_vnum]);
  iq.DoModal();
	bt = new BuyType;
	bt->obj_type = iq.value;
	bt->accept_string = "";
  lshop->buy_list.push_back(*bt);

  LoadSedit();
	
}


void Sedit::OnShopDeleteBuy() 
{
	CString temp;

	Shop *lshop;
	int shop_vnum= theApp.dlg->current_shop;
  lshop = &(the_world.shop_list[shop_vnum]);
	((CComboBox *) GetDlgItem(IDC_SHOP_BUY_COMBO))->GetWindowText(temp);
	lshop->delete_buy(iprintf("%s",temp));

	LoadSedit();
}

void Sedit::OnChangeShopBuyNamelist() 
{
	vector<BuyType>::iterator exd;
	int count;
	extern World the_world;
	extern CCbreakApp theApp;
  Shop *lshop;
	int shop_vnum= theApp.dlg->current_shop;	

	UpdateData(TRUE);
  lshop = &(the_world.shop_list[shop_vnum]);
	count=((CComboBox *) GetDlgItem(IDC_SHOP_BUY_COMBO))->GetCurSel();
	
	for(exd=lshop->buy_list.begin();count > 0;count--) {
	  exd++;	
  }
	/* wonder if this will work. Both 'support' to<=>from char * conversions but not
		 work well with others */ 
	exd->accept_string = m_shop_namelist;

}

void Sedit::OnSelchangeShopBuyCombo() 
{
	vector<BuyType>::const_iterator exd;
	int count;
	extern World the_world;
	extern CCbreakApp theApp;
  Shop *lshop;
	int shop_vnum= theApp.dlg->current_shop;	

  lshop = &(the_world.shop_list[shop_vnum]);
	count=((CComboBox *) GetDlgItem(IDC_SHOP_BUY_COMBO))->GetCurSel();
	
	for(exd=lshop->buy_list.begin();count > 0;count--) {
	  exd++;	
  }
	m_shop_namelist = exd->accept_string.c_str();
	
	UpdateData(FALSE);		
}

void Sedit::OnShopTrade() 
{
  BitvectorSel rf(the_world.shop_list[theApp.dlg->current_shop].with_who,"Trade Flags");
  rf.DoModal();
  the_world.shop_list[theApp.dlg->current_shop].with_who=rf.total;
	 
}

void Sedit::OnShopSave() 
{
  int zone = the_world.shop_list[theApp.dlg->current_shop].zone;
  the_world.save_zone(zone);
    AfxMessageBox("The zone is saved.\n",MB_OK);
}

void Sedit::OnShopNewShop() 
{
  NewShop sp;
  sp.DoModal();
}

void Sedit::OnShopDeleteShop() 
{
  int delshop = theApp.dlg->current_shop;

  if(AfxMessageBox("Are you sure you wish to delete this shop?",
	  MB_YESNO | MB_APPLMODAL | MB_ICONQUESTION) == IDYES) {
    OnShopNext();
    the_world.shop_list.erase(delshop);
  }	
}

void Sedit::disable_sedit(int all)
{
  int i;

	for(i=ID_ZONE_NUMBER;i <IDC_ZCMD_SAVE;i++){
		if(GetDlgItem(i)) {
      GetDlgItem(i)->EnableWindow(FALSE);
		}
	}
	if(all == -1) {
		return;
	}
  GetDlgItem(IDC_SHOP_SAVE)->EnableWindow(TRUE);
  GetDlgItem(IDC_SHOP_NEW_SHOP)->EnableWindow(TRUE);

	if(all == 1) {
  	for(i=ID_ZONE_NUMBER;i <IDC_ZCMD_SAVE;i++){
	  	if(GetDlgItem(i)) {
        GetDlgItem(i)->EnableWindow(TRUE);
			}
		}
	}
}

BOOL Sedit::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	if(!are_there_zones()) {
    disable_sedit(-1);
	} else if (the_world.shop_list.empty()) {
		disable_sedit(0);
	} else {
		disable_sedit(1);
  }	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
