/*
		zedit.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Primary control dialog for the zedit window.
*/
#pragma warning(disable:4786)
#include "stdafx.h"
#include "Cbreak.h"
#include "Zedit.h"
#include "utils.h"
#include "JumpToRoom.h"
#include "EditZcmd.h"

extern World the_world;
extern CCbreakApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Zedit property page



IMPLEMENT_DYNCREATE(Zedit, CPropertyPage)

Zedit::Zedit() : CPropertyPage(Zedit::IDD)
{
	//{{AFX_DATA_INIT(Zedit)
	m_zone_number = 0;
	m_zone_lifespan = 0;
	m_reset_mode = -1;
	m_zone_name = _T("");
	m_zone_range = _T("");
	m_room_name = _T("");
	//}}AFX_DATA_INIT
}



Zedit::~Zedit()
{
}

void Zedit::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Zedit)
	DDX_Control(pDX, ID_ZONE_NAME, e_zone_name);
	DDX_Control(pDX, ID_ROOM_NAME, e_room_name);
	DDX_Control(pDX, IDC_ZONE_NUM, m_room_number);
	DDX_Control(pDX, IDC_ZCMD_LIST, m_zcmd_list);
	DDX_Text(pDX, ID_ZONE_NUMBER, m_zone_number);
	DDX_Text(pDX, ID_ZONE_LIFESPAN, m_zone_lifespan);
	DDX_CBIndex(pDX, IDC_RESET_MODE, m_reset_mode);
	DDX_Text(pDX, ID_ZONE_NAME, m_zone_name);
	DDX_Text(pDX, ID_ZONE_RANGE, m_zone_range);
	DDX_Text(pDX, ID_ROOM_NAME, m_room_name);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Zedit, CPropertyPage)
	//{{AFX_MSG_MAP(Zedit)
	ON_BN_CLICKED(IDC_ZONE_NUM, OnZoneNum)
	ON_CBN_EDITCHANGE(IDC_RESET_MODE, OnEditchangeResetMode)
	ON_EN_CHANGE(ID_ZONE_NAME, OnChangeZoneName)
	ON_EN_CHANGE(ID_ZONE_LIFESPAN, OnChangeZoneLifespan)
	ON_EN_CHANGE(ID_ROOM_NAME, OnChangeRoomName)
	ON_BN_CLICKED(IDC_NEXT_ZONE, OnNextZone)
	ON_BN_CLICKED(IDC_NEXT_ZONEZ, OnNextZonez)
	ON_BN_CLICKED(IDC_PREVIOUS_ZONE, OnPreviousZone)
	ON_BN_CLICKED(IDC_PREVIOUS_ZONEZ, OnPreviousZonez)
	ON_LBN_DBLCLK(IDC_ZCMD_LIST, OnDblclkZcmdList)
	ON_BN_CLICKED(IDC_ZCMD_ADD, OnZcmdAdd)
	ON_BN_CLICKED(IDC_ZCMD_EDIT, OnZcmdEdit)
	ON_BN_CLICKED(IDC_ZCMD_DELETE, OnZcmdDelete)
	ON_BN_CLICKED(IDC_ZCMD_SAVE, OnZcmdSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Zedit message handlers




void Zedit::OnZoneNum() 
{
  JumpToRoom jumper(0);
  jumper.DoModal();
}



BOOL Zedit::OnSetActive() 
{
;
	if(theApp.dlg->current_room >= 0) {
		LoadZedit();
	}
	this->UpdateData();
	return CPropertyPage::OnSetActive();	
}


extern const char *dirs[];
extern const char *equip_positions[];
extern const char *door_state[];


void Zedit::LoadZedit()
{
	int tabstops[3] = {50,90};
	Room *lroom;

	int i;
  vector<Zone_Cmd_Data>::iterator zc;
 
  int room_vnum= theApp.dlg->current_room;

  	if(!are_there_zones()) {
    disable_zedit(-1);
	} else if (the_world.room_list.empty()) {
		disable_zedit(0);
	} else {
		disable_zedit(1);
  }	
	if(room_vnum < 0){
		return;
	}

	lroom = &(the_world.room_list[room_vnum]);
  CSortDragListBox *zlist = ((CSortDragListBox *) GetDlgItem(IDC_ZCMD_LIST));
  m_zone_number = the_world.zone_list[lroom->zone].number;
	m_zone_lifespan=the_world.zone_list[lroom->zone].lifespan;
	m_reset_mode=the_world.zone_list[lroom->zone].reset_mode;
	m_zone_name=the_world.zone_list[lroom->zone].name.c_str();
	m_zone_range=iprintf("%d-%d",the_world.zone_list[lroom->zone].number *100,
		the_world.zone_list[lroom->zone].top);
  m_room_name = iprintf("%s",lroom->name.c_str());

  m_room_number.SetWindowText(iprintf("%d",lroom->number));
	zlist->SetTabStops(2,tabstops);
    zlist->SetHorizontalExtent(2000);
	/* here's the 'fun' part. heh. */
  zlist->ResetContent();

  /* lets fix the columns  */
 //  zlist->header
  // have to do this later...

	if(!lroom->zonecmd.empty()) {   
		for(i=1,zc=lroom->zonecmd.begin();zc!=lroom->zonecmd.end();zc++,i++) {
			switch(zc->cmd) {
  			case 'M':
					zlist->AddString(iprintf("%d\t%s\tLoad %s [vnum %d], max of %d",i,zc->depend ? "Yes" : "No", 
							(the_world.mob_list.find(zc->arg[0]) != the_world.mob_list.end()) ?
							the_world.mob_list[zc->arg[0]].sdesc.c_str() : "Unknown", zc->arg[0], zc->arg[1]));
					break;
				case 'G':
					zlist->AddString(iprintf("%d\t%s\t   and give it %s [vnum %d], max of %d",i,zc->depend ? "Yes" : "No",
					    (the_world.obj_list.find(zc->arg[0]) != the_world.obj_list.end()) ?
							the_world.obj_list[zc->arg[0]].sdesc.c_str() : "Unknown", zc->arg[0], zc->arg[1]));
					break;
				case 'O':
					zlist->AddString(iprintf("%d\t%s\tLoad obj %s [vnum %d] to room, max of %d",i,zc->depend ? "Yes" : "No",
					    (the_world.obj_list.find(zc->arg[0]) != the_world.obj_list.end()) ?
							the_world.obj_list[zc->arg[0]].sdesc.c_str() : "Unknown", zc->arg[0], zc->arg[1]));
					break;
				case 'E':
					zlist->AddString(iprintf("%d\t%s\t   and equip it with %s [vnum %d], %s , max of %d",i,zc->depend ? "Yes" : "No",
					    (the_world.obj_list.find(zc->arg[0]) != the_world.obj_list.end()) ?
							the_world.obj_list[zc->arg[0]].sdesc.c_str() : "Unknown", zc->arg[0],
							equip_positions[zc->arg[2]], zc->arg[1]));
					break;
				case 'P':
					zlist->AddString(iprintf("%d\t%s\tPut obj %s [vnum %d] into %s [vnum %d], max of %d",i,zc->depend ? "Yes" : "No",
					    (the_world.obj_list.find(zc->arg[0]) != the_world.obj_list.end()) ?
							the_world.obj_list[zc->arg[0]].sdesc.c_str() : "Unknown", zc->arg[0],
			  	    (the_world.obj_list.find(zc->arg[2]) != the_world.obj_list.end()) ?
							the_world.obj_list[zc->arg[2]].sdesc.c_str() : "Unknown", zc->arg[2],
							zc->arg[1]));
					break;
				case 'R':
					zlist->AddString(iprintf("%d\t%s\tRemove obj %s [vnum %d] from room",i,zc->depend ? "Yes" : "No",
					    (the_world.obj_list.find(zc->arg[1]) != the_world.obj_list.end()) ?
							the_world.obj_list[zc->arg[1]].sdesc.c_str() : "Unknown", zc->arg[1]));
					break;
				case 'D':
					zlist->AddString(iprintf("%d\t%s\tSet door %s as %s",i,zc->depend ? "Yes" : "No",
					    dirs[zc->arg[1]],door_state[zc->arg[2]]));
					break;
				default:
					break;
			}
		}
	}
  zlist->AddString("\t\tAdd new command....");


 	UpdateData(FALSE);	
}

void Zedit::OnChangeZoneName() 
{
  Zone_Data *lzone;
  UpdateData(TRUE);

  lzone = &(the_world.zone_list[m_zone_number]);
	lzone->name = m_zone_name;
	
}

void Zedit::OnChangeZoneLifespan() 
{
  Zone_Data *lzone;
  UpdateData(TRUE);

  lzone = &(the_world.zone_list[m_zone_number]);
	lzone->lifespan = m_zone_lifespan;
	
}

void Zedit::OnEditchangeResetMode() 
{
  Zone_Data *lzone;
  UpdateData(TRUE);

  lzone = &(the_world.zone_list[m_zone_number]);
	lzone->reset_mode = m_reset_mode;	
}

void Zedit::OnChangeRoomName() 
{
	Room *lroom;

	int room_vnum= theApp.dlg->current_room;
  UpdateData(TRUE);
  lroom = &(the_world.room_list[room_vnum]);
  lroom->name = m_room_name;
}

void Zedit::OnNextZone() 
{
	extern CCbreakApp theApp;
  int room_num = theApp.dlg->current_room;
  map<int, Room>::const_iterator ri;

	ri=the_world.room_list.find(room_num);
	if(ri == the_world.room_list.end()) {
		/* this is a serious problem. indicates the current room DNE! */
		error("Uh. The current room doesn't exist?");
	} 
	ri++;
	if(ri == the_world.room_list.end()) {
		ri=the_world.room_list.begin();
  }
	theApp.dlg->current_room = ri->first;

	LoadZedit();

}

void Zedit::OnPreviousZone() 
{
	extern CCbreakApp theApp;
  int room_num = theApp.dlg->current_room;
  map<int, Room>::const_iterator ri;

	ri=the_world.room_list.find(room_num);
	if(ri == the_world.room_list.end()) {
		/* this is a serious problem. indicates the current room DNE! */
		error("Uh. The current room doesn't exist?");
	} 
	if(ri == the_world.room_list.begin()) {
		ri= the_world.room_list.end();
	}
	ri--;
	if(ri == the_world.room_list.end()) {
		ri=the_world.room_list.begin();
  }
	theApp.dlg->current_room = ri->first;

	LoadZedit();
}

void Zedit::OnNextZonez() 
{
	extern CCbreakApp theApp;
  int room_num = theApp.dlg->current_room;
  map<int,Zone_Data>::const_iterator zi;
  map<int,Room>::const_iterator ri;

	zi = the_world.zone_list.find(the_world.room_list[room_num].zone);
	if(zi==the_world.zone_list.end()) {
		error("Crapbuger. The current zone does not exist.");
	}
  	
	for(ri=the_world.room_list.find(room_num);ri != the_world.room_list.end();ri++) {
  	if(the_world.room_list[ri->first].zone != the_world.room_list[room_num].zone) {
      break;
		}
	}
	if(ri == the_world.room_list.end()) {
		ri=the_world.room_list.begin();
	}

	theApp.dlg->current_room = ri->first;
	this->LoadZedit();
}

void Zedit::OnPreviousZonez() 
{
 	extern CCbreakApp theApp;
  int room_num = theApp.dlg->current_room;
  map<int,Zone_Data>::const_iterator zi;
  map<int,Room>::const_iterator ri;

	zi = the_world.zone_list.find(the_world.room_list[room_num].zone);
	if(zi==the_world.zone_list.end()) {
		error("Crapbuger. The current zone does not exist.");
	}
  	
	for(ri=the_world.room_list.find(room_num);ri != the_world.room_list.begin();ri--) {
  	if(the_world.room_list[ri->first].zone != the_world.room_list[room_num].zone) {
      break;
		}
	}

	if(ri == the_world.room_list.begin() && the_world.room_list[ri->first].zone ==
			the_world.room_list[room_num].zone) {
		ri=the_world.room_list.end();
		ri--;
	}

	theApp.dlg->current_room = ri->first;
	this->LoadZedit();
}

void Zedit::OnDblclkZcmdList() 
{
  int nSelection = m_zcmd_list.GetCurSel();
  
  if( nSelection != LB_ERR ) {
	  if(nSelection == m_zcmd_list.GetCount() - 1) {
		  OnZcmdAdd();
	  } else {
		  OnZcmdEdit();
	  }
  }
  return;
}

extern char num_to_cmd[];

void Zedit::OnZcmdAdd() 
{
	Zone_Cmd_Data *zc;

  EditZcmd ez(-1,0,-1,-1,-1);
  ez.DoModal();

	if(ez.m_type != -1) {
		zc = new Zone_Cmd_Data;
		zc->arg[0] = ez.arg[0];
		zc->arg[1] = ez.arg[1];
		zc->arg[2] = ez.arg[2];
		zc->depend = ez.m_depend;
    zc->cmd = num_to_cmd[ez.m_type];
		the_world.room_list[theApp.dlg->current_room].zonecmd.push_back(*zc);
	}
	LoadZedit();
	
}



void Zedit::OnZcmdEdit() 
{
  EditZcmd *ez;
  int x;
  int nSelection = m_zcmd_list.GetCurSel();
  Zone_Cmd_Data *zc;

	if(nSelection == LB_ERR) {
		MessageBox("You must actually have something SELECTED to edit it!");
		return;
	}

  if(nSelection != m_zcmd_list.GetCount()-1) {
	  zc = &(the_world.room_list[theApp.dlg->current_room].zonecmd[nSelection]);
	  switch(zc->cmd) {
	    case 'M':
        x=0;
		    break;
	    case 'O':
	  	  x=1;
		    break;
	    case 'G':
	     	x=2;
	  	  break;
	    case 'E':
	    	x=3;
	  	  break;
	    case 'P':
	  	  x=4;
	  	  break;
	    case 'D':
		    x=5;
	      break;
	    case 'R':
		    x=6;
 	  		break;
		}
    ez= new EditZcmd(zc->depend,x,zc->arg[0],zc->arg[1],zc->arg[2]);
	  ez->DoModal();
		if(ez->m_type != -1) {
  	  zc->depend = ez->m_depend;
	    zc->arg[0] = ez->arg[0];
	    zc->arg[1] = ez->arg[1];
	    zc->arg[2] = ez->arg[2];
      zc->cmd = num_to_cmd[ez->m_type];
		}
		delete(ez);
  } else {
		MessageBox("You cannot edit this line...try adding, instead.");
	}
	LoadZedit();

}

void Zedit::OnZcmdDelete() 
{
  int nSelection = m_zcmd_list.GetCurSel();
		
	if(nSelection == LB_ERR) {
		MessageBox("You must actually have something SELECTED to delete it!");
		return;
	}
	if(nSelection != m_zcmd_list.GetCount()-1) {
    the_world.room_list[theApp.dlg->current_room].zonecmd.erase(
			the_world.room_list[theApp.dlg->current_room].zonecmd.begin() + nSelection);
	} else {
		MessageBox("You cannot delete that :P");
		return;
	}
	LoadZedit();
}

void Zedit::OnZcmdSave() 
{
	int zone = the_world.room_list[theApp.dlg->current_room].zone;
  the_world.save_zone(zone);
  AfxMessageBox("The zone is saved.\n",MB_OK);
}

void Zedit::disable_zedit(int all)
{
  int i;

	for(i=ID_ZONE_NUMBER;i <IDC_ZCMD_SAVE;i++){
		if(GetDlgItem(i)) {
      GetDlgItem(i)->EnableWindow(FALSE);
		}
	}
	if(all == -1) {
		return;
	}
  GetDlgItem(IDC_ZCMD_SAVE)->EnableWindow(TRUE);

	if(all == 1) {
  	for(i=ID_ZONE_NUMBER;i <IDC_ZCMD_SAVE;i++){
	  	if(GetDlgItem(i)) {
        GetDlgItem(i)->EnableWindow(TRUE);
			}
		}
	}

}

BOOL Zedit::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	if(!are_there_zones()) {
    disable_zedit(-1);
	} else if (the_world.room_list.empty()) {
		disable_zedit(0);
	} else {
		disable_zedit(1);
  }		
	return TRUE;
}
